<?php

/*------------------------------------------------------------------------
# mod_virtuemart_magicscroll - Magic Scroll for Joomla with VirtueMart
# ------------------------------------------------------------------------
# Magic Toolbox
# Copyright 2011 MagicToolbox.com. All Rights Reserved.
# @license - http://www.opensource.org/licenses/artistic-license-2.0  Artistic License 2.0 (GPL compatible)
# Website: http://www.magictoolbox.com/magicscroll/modules/virtuemart/
# Technical Support: http://www.magictoolbox.com/contact/
/*-------------------------------------------------------------------------*/

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

include_once 'init.php';

isset($INSTALLMODE) or $INSTALLMODE = '';

$msg = array();

//Import joomla libraries
mz_jimport('joomla.filesystem.file');
mz_jimport('joomla.filesystem.folder');
mz_jimport('joomla.filesystem.archive');

if(class_exists('joomlaVersion')) {
    //old joomla, 1.0.x
    $versionObj = new joomlaVersion();
} elseif(class_exists('JVersion')) {
    $versionObj = new JVersion();
}
if(version_compare($versionObj->getShortVersion(), '1.6.0', '<')) {
    $jm17 = false;
} else {
    $jm17 = true;
}

$vm2 = false;
$vmVersionFile = dirname(__FILE__).DS.'..'.DS.'com_virtuemart'.DS.'version.php';
if(file_exists($vmVersionFile)) {
    include_once $vmVersionFile;
    $vmVersion = preg_replace('/^[a-zA-Z]+\s(\d(?:\.\d)*).*$/is', '$1', $shortversion);
    if(version_compare($vmVersion, '2.0.0', '>=')) {
        $vm2 = true;
    }
}

switch ($INSTALLMODE) {
    case 'install':

        $prepare_queries = array();
        $create_table_queries = array();
        $alter_table_queries = array();
        $sample_data_insert = array();
        $end_queries = array();

        //Magic Scroll frontend module installation

        function mz_copyModuleFiles($from, $to) {
            JFolder::copy($from, $to);
            if(!defined('_JEXEC')) {
                // jm 1.0
                JFile::move($to . DS . 'mod_virtuemart_magicscroll.php', $to . DS.'..'.DS.'mod_virtuemart_magicscroll.php');
                JFile::move($to . DS . 'mod_virtuemart_magicscroll_10.xml', $to . DS.'..'.DS.'mod_virtuemart_magicscroll.xml');
                JFile::delete($to . DS . 'mod_virtuemart_magicscroll.xml');
                $url = $GLOBALS['mosConfig_live_site'] . '/modules/mod_virtuemart_magicscroll/core';
            } else {
                //JFile::delete($to . DS . 'mod_virtuemart_magicscroll_10.xml');
                //$url = JURI::base() . '/modules/mod_virtuemart_magicscroll/core';
                $url = JURI::base() . 'modules/mod_virtuemart_magicscroll/core';
            }

            $css = $to . DS . 'core' . DS . 'magicscroll.css';
            $c = file_get_contents($css);
            $url = preg_replace('/https?:\/\/[^\/]+\//is', '/', $url);
            $url = str_replace('administrator/', '', $url);
            $url = str_replace('//', '/', $url);
            $pattern = '/url\(\s*(?:\'|")?(?!'.preg_quote($url, '/').')\/?([^\)\s]+?)(?:\'|")?\s*\)/is';
            $replace = 'url(' . $url . '/$1)';
            $c = preg_replace($pattern, $replace, $c);
            file_put_contents($css, $c);

            return true;
        }


        $mz_modDstPath = join(DS,array(dirname(__FILE__),'..','..','..','modules','mod_virtuemart_magicscroll'));
        $mz_modFile = join(DS,array(dirname(__FILE__),'module'));

        $mz_clean = array($mz_modDstPath);

        if(!defined('_JEXEC')) {
            $mz_clean = array(
                    $mz_modDstPath,
                    $mz_modDstPath.DS.'..'.DS.'mod_virtuemart_magicscroll.php',
                    $mz_modDstPath.DS.'..'.DS.'mod_virtuemart_magicscroll.xml',
            );
        }

        //clean folders and file of previous installation
        foreach($mz_clean as $delFile) {
            if(file_exists($delFile)){
                if(is_file($delFile)){
                    JFile::delete($delFile);
                } else
                if(is_dir($delFile)){
                    JFolder::delete($delFile);
                }
            }
        }

        $prepare_queries[] = 'SET FOREIGN_KEY_CHECKS=0';
        $prepare_queries[] = 'SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO"';

        $prepare_queries[] = 'DROP TABLE IF EXISTS `#__virtuemart_magicscroll_config`';

        //if(JArchive::extract($mz_modFile,$mz_modDstPath)) {
        if(mz_copyModuleFiles($mz_modFile,$mz_modDstPath)) {
            $msg[]='Magic Scroll v4.4.42 [v1.2.16:v1.0.19] frontend module installed successfuly';

            $prepare_queries[] = 'DELETE FROM `#__modules_menu` WHERE `moduleid` = (SELECT id FROM `#__modules` WHERE `module` = \'mod_virtuemart_magicscroll\')';
            $prepare_queries[] = 'DELETE FROM `#__modules` WHERE `module` = \'mod_virtuemart_magicscroll\'';

            $sample_data_insert[] = 'INSERT INTO `#__extensions` (`name`, `type`, `element`, `folder`, `enabled`, `protected`, `access`, `client_id`, `params`) VALUES
            (\'Magic Scroll v4.4.42 [v1.2.16:v1.0.19] module for Joomla with VirtueMart\', \'module\', \'mod_virtuemart_magicscroll\', \'\', 1, 0, 0, 0, \'\')';

            $sample_data_insert[] = 'INSERT INTO `#__modules` (`title`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`) VALUES
            (\'Magic Scroll v4.4.42 [v1.2.16:v1.0.19] module for Joomla with VirtueMart\', \'\', 0, \'' . ( $jm17 ? 'position-3' : 'left') . '\', 0, NOW(), 1, \'mod_virtuemart_magicscroll\', 1, 0, \'\', 0)';

            $sample_data_insert[] = 'INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES (LAST_INSERT_ID(),0)';

        } else {
            $msg[]="Error installing Magic Scroll v4.4.42 [v1.2.16:v1.0.19] frontend module. Please try to install it manualy ($mz_modFile)";
        }

        //End of Magic Scroll frontend module installation

        //End


        $create_table_queries[] = 'CREATE TABLE IF NOT EXISTS `#__virtuemart_magicscroll_config` (
          `id` int(11) NOT NULL auto_increment COMMENT \'default profile should have id = 1\',
          `profile` varchar(32) character set utf8 NOT NULL,
          `config` text character set utf8 NOT NULL,
          PRIMARY KEY  (`id`)
        ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0';


        $sample_data_insert[] = "INSERT IGNORE INTO `#__virtuemart_magicscroll_config` (`id`, `profile`, `config`) VALUES
        (1, 'default', ''),
        (2, 'browse', 'show-message:No;zoom-position:inner;click-to-activate:true;message:Click to zoom;multiple-images:No'),
        (3, 'details', 'thumb-max-width:100;direction:right'),
        (4, 'latest', 'show-message:No;opacity-reverse:true;use-original-vm-thumbnails:Yes'),
        (5, 'featured', 'show-message:No;opacity-reverse:true;use-original-vm-thumbnails:Yes'),
        (6, 'random', 'show-message:No;opacity-reverse:true;use-original-vm-thumbnails:Yes'),
        (7, 'custom', '')";


        $queries = array_merge($prepare_queries,$create_table_queries,$alter_table_queries,$sample_data_insert,$end_queries);

        $db = JFactory::getDBO();
        foreach($queries as $q) {
            $db->setQuery($q);
            $db->query();
        }

        JFile::move(__FILE__, dirname(__FILE__).DS.'install.un.php');
        if(defined('_JEXEC')) {
            JFile::move(dirname(__FILE__).DS.'magicscroll_10.xml', dirname(__FILE__).DS.'magicscroll_10_xml.back');
        }

        echo "<h2>Magic Scroll component installed successfully.</h2>";
        echo '<p>'.join("</p><p>",$msg).'</p>';
        echo "<h2>Press F5 to refresh the page.</h2>";
        break;

    case 'uninstall';
        $tables = array('magicscroll_config');
        //if VirtueMart is still installed using their DB class
        if(class_exists('ps_DB')) {
            $db = new ps_DB;
            $dbvmprefix = '#__virtuemart';
            $dbprefix = '#__';

        } else if(class_exists('JFactory')) {
            //if Joomla 1.5
            $db = JFactory::getDBO();
            $CONFIG = new JConfig();
            if($vm2) {
                $dbvmprefix = $CONFIG->dbprefix.'virtuemart';
            } else {
                $dbvmprefix = $CONFIG->dbprefix.'vm';
            }
            $dbprefix = $CONFIG->dbprefix;

        } else {
            //if Joomla 1.0.x
            global $database, $mosConfig_dbprefix;

            $db = $database;
            $dbvmprefix = $mosConfig_dbprefix.'vm';
            $dbprefix = $mosConfig_dbprefix;
        }

        foreach($tables as $t) {
            $db->setQuery( "DROP TABLE `{$dbvmprefix}_{$t}`;" );
            $db->query();
        }

        $db->setQuery("SELECT id FROM `{$dbprefix}modules` WHERE `module` = 'mod_virtuemart_magicscroll'");
        $db->query();

        $module_id = $db->loadResult();

        $db->setQuery("SELECT extension_id FROM `{$dbprefix}extensions` WHERE `element` = 'mod_virtuemart_magicscroll'");
        $db->query();

        $element_id = $db->loadResult();

        $mz_modDstPath = join(DS,array(dirname(__FILE__),'..','..','..','modules','mod_virtuemart_magicscroll'));
        if($module_id && JFolder::delete($mz_modDstPath)) {

            $db->setQuery("DELETE FROM `{$dbprefix}modules` WHERE `id` = $module_id");
            $db->query();
            $db->setQuery("DELETE FROM `{$dbprefix}extensions` WHERE `extension_id` = $element_id");
            $db->query();
            //$db->setQuery("SELECT id FROM `{$dbprefix}modules_menu` WHERE `moduleid` = $module_id");
            $db->setQuery("DELETE FROM `{$dbprefix}modules_menu` WHERE `moduleid` = $module_id");
            $db->query();

            echo "<h2>Magic Scroll component uninstalled. Frontend module removed</h2>";
        } else {
            echo "<h2>Magic Scroll component uninstalled, please uninstall 'Magic Scroll' module manualy.</h2>";
        }

        break;
    default:
        echo "<h2>Installation mode is not set. Nothing done.</h2>";
        break;
}
